# 0.0.3 - 2019-03-21

- [PyPI](https://pypi.org/project/river/0.0.3/)
- [GitHub](https://github.com/online-ml/river/releases/tag/0.0.3)

## base

- Calling `fit_one` now returns the calling instance, not the out-of-fold prediction/transform; `fit_predict_one`, `fit_predict_proba_one`, and `fit_transform_one` are available to reproduce the previous behavior.
- Binary classifiers now output a `dict` with probabilities for `False` and `True` when calling `predict_proba_one`, which solves the interface issues of having multi-class classifiers do binary classification.

## compat

- Added `compat.convert_river_to_sklearn`.

## compose

- Added `compose.BoxCoxTransformRegressor`.
- Added `compose.TargetModifierRegressor`.

## datasets

- Added `datasets.fetch_restaurants`.
- Added `datasets.load_airline`.

## dist

- Added `dist.Multinomial`.
- Added `dist.Normal`.

## ensemble

- Added `ensemble.BaggingRegressor`.

## feature_extraction

- Added `feature_extraction.TargetGroupBy`.

## impute

- Added `impute.CategoricalImputer`.

## linear_model

- Added `linear_model.FMRegressor`.
- Removed all the passive-aggressive estimators.

## metrics

- Added `metrics.Accuracy`.
- Added `metrics.MAE`.
- Added `metrics.MSE`.
- Added `metrics.RMSE`.
- Added `metrics.RMSLE`.
- Added `metrics.SMAPE`.
- Added `metrics.Precision`.
- Added `metrics.Recall`.
- Added `metrics.F1`.

## model_selection

- `model_selection.online_score` can now be passed a `metrics.Metric` instead of an `sklearn` metric; it also checks that the provided metric can be used with the accompanying model.

## naive_bayes

- Added `naive_bayes.GaussianNB`.

## optim

- Added `optim.PassiveAggressiveI`.
- Added `optim.PassiveAggressiveII`.

## preprocessing

- Added `preprocessing.Discarder`.
- Added `preprocessing.PolynomialExtender`.
- Added `preprocessing.FuncTransformer`.

## reco

- Added `reco.SVD`.

## stats

- Added `stats.Mode`.
- Added `stats.Quantile`.
- Added `stats.RollingQuantile`.
- Added `stats.Entropy`.
- Added `stats.RollingMin`.
- Added `stats.RollingMax`.
- Added `stats.RollingMode`.
- Added `stats.RollingSum`.
- Added `stats.RollingPeakToPeak`.

## stream

- Added `stream.iter_csv`.

## tree

- Added `tree.MondrianTreeClassifier`.
- Added `tree.MondrianTreeRegressor`.
