# 0.4.1 - 2019-10-23

- [PyPI](https://pypi.org/project/river/0.4.1/)
- [GitHub](https://github.com/online-ml/river/releases/tag/0.4.1)

## base

- Tests are now much more extensive, thanks mostly to the newly added estimator tags.

## compose

- Added `compose.Renamer`.

## datasets

- Added `fetch_kdd99_http`.
- Added `fetch_sms`.
- Added `fetch_trec07p`.

## ensemble

- Removed `ensemble.HedgeBinaryClassifier` because it's performance was subpar.
- Removed `ensemble.GroupRegressor`, as this should be a special case of `ensemble.StackingRegressor`.

## feature_extraction

- Fixed a bug where `feature_extraction.CountVectorizer` and `feature_extraction.TFIDFVectorizer` couldn't be pickled.

## linear_model

- `linear_model.LogisticRegression` and `linear_model.LinearRegression` now have an `intercept_lr` parameter.

## metrics

- Metrics can now be composed using the `+` operator, which is useful for evaluating multiple metrics at the same time.
- Added `metrics.Rolling`, which eliminates the need for a specific rolling implementation for each metric.
- Each metric can now be passed a `sample_weight` argument.
- Added `metrics.WeightedF1`.
- Added `metrics.WeightedFBeta`.
- Added `metrics.WeightedPrecision`.
- Added `metrics.WeightedRecall`.

## neighbors

- Added `neighbors.KNeighborsRegressor`.
- Added `neighbors.KNeighborsClassifier`.

## optim

- Added `optim.AdaMax`.
- The `optim` module has been reorganized into submodules; namely `optim.schedulers`, `optim.initializers`, and `optim.losses`. The top-level now only contains optimizers. Some classes have been renamed accordingly. See the documentation for details.
- Renamed `optim.VanillaSGD` to `optim.SGD`.

## stats

- Added `stats.IQR`.
- Added `stats.RollingIQR`.
- Cythonized `stats.Mean` and `stats.Var`.

## stream

- Added `stream.shuffle`.
- `stream.iter_csv` now has `fraction` and `seed` parameters to sample rows, deterministically or not.
- Renamed `stream.iter_numpy` to `stream.iter_array`.
- `stream.iter_csv` can now read from gzipped files.

## time_series

- `time_series.Detrender` now has a `window_size` parameter for detrending with a rolling mean.

## tree

- Added `tree.RandomForestClassifier`.

## utils

- Fixed a bug where `utils.dot` could take longer than necessary.
