# 0.5.0 - 2020-03-13

- [PyPI](https://pypi.org/project/river/0.5.0/)
- [GitHub](https://github.com/online-ml/river/releases/tag/0.5.0)

## compat

- Added `compat.PyTorch2CremeRegressor`.
- `compat.SKL2CremeRegressor` and `compat.SKL2CremeClassifier` now have an optional `batch_size` parameter in order to perform mini-batching.

## compose

- Renamed `compose.Whitelister` to `compose.Select`.
- Renamed `compose.Blacklister` to `compose.Discard`.

## facto

- Added `facto.FFMClassifier`.
- Added `facto.FFMRegressor`.
- Added `facto.FwFMClassifier`.
- Added `facto.FwFMRegressor`.
- Added `facto.HOFMClassifier`.
- Added `facto.HOFMRegressor`.
- Refactored `facto.FMClassifier`.
- Refactored `facto.FMRegressor`.

## feature_selection

- Added `feature_selection.PoissonInclusion`.
- Removed `feature_selection.RandomDiscarder` as it didn't make much sense.

## feature_extraction

- Renamed `feature_extraction.CountVectorizer` to `feature_extraction.BagOfWords`.
- Renamed `feature_extraction.TFIDFVectorizer` to `feature_extraction.TFIDF`.
- Added `preprocessor` and `ngram_range` parameters to `feature_extraction.BagOfWords`.
- Added `preprocessor` and `ngram_range` parameters to `feature_extraction.TFIDF`.

## datasets

- The `datasets` module has been overhauled. Each dataset is now a class (e.g. `fetch_electricity` has become `datasets.Elec2`).
- Added `datasets.TrumpApproval`.
- Added `datasets.MaliciousURL`.
- Added `datasets.gen.SEA`.
- Added `datasets.Higgs`.
- Added `datasets.MovieLens100K`.
- Added `datasets.Bananas`.
- Added `datasets.Taxis`.
- Added `datasets.ImageSegments`.
- Added `datasets.SMTP`

## impute

- Added `impute.PreviousImputer`.

## linear_model

- `linear_model.FMClassifier` has been moved to the `facto` module.
- `linear_model.FMRegressor` has been  moved to the `facto` module.
- Added `linear_model.ALMAClassifier`.

## metrics

- Added `metrics.ClassificationReport`.
- Added `metrics.TimeRolling`.
- The implementation of `metrics.ROCAUC` was incorrect. Using the trapezoidal rule instead of Simpson's rule seems to be more robust.
- `metrics.PerClass` has been removed; it is recommended that you use `metrics.ClassificationReport` instead as it gives a better overview.

## meta

- Moved `meta.TransformedTargetRegressor` and `meta.BoxCoxRegressor` to this module (they were previously in the `compose` module).
- Added `meta.PredClipper`

## model_selection

- Added `model_selection.expand_param_grid` to generate a list of models from a grid of parameters.
- Added the `model_selection.successive_halving` method for selecting hyperparameters.
- The `online_score` and `online_qa_score` methods have been merged into a single method named `model_selection.progressive_val_score`.

## preprocessing

- Added `preprocessing.RBFSampler`.
- Added `preprocessing.MaxAbsScaler`.
- Added `preprocessing.RobustScaler`.
- Added `preprocessing.Binarizer`.
- Added `with_mean` and `with_std` parameters to `preprocessing.StandardScaler`.

## optim

- Added `optim.losses.BinaryFocalLoss`.
- Added the `optim.AMSGrad` optimizer.
- Added the `optim.Nadam` optimizer.
- Added `optim.losses.Poisson`.
- Fixed a performance bug in `optim.NesterovMomentum`.

## reco

- Added `reco.FunkMF`.
- Renamed `reco.SVD` to `reco.BiasedMF`.
- Renamed `reco.SGDBaseline` to `reco.Baseline`.
- Models now expect a `dict` input with `user` and `item` fields.

## sampling

- Added `sampling.RandomUnderSampler`.
- Added `sampling.RandomOverSampler`.
- Added `sampling.RandomSampler`.
- Added `sampling.HardSamplingClassifier`.
- Added `sampling.HardSamplingRegressor`.

## stats

- Added `stats.AbsMax`.
- Added `stats.RollingAbsMax`.

## stream

- Added `stream.iter_libsvm`.
- `stream.iter_csv` now supports reading from '.zip' files.
- Added `stream.Cache`.
- Added a `drop` parameter to `stream.iter_csv` to discard fields.
