# 0.6.0 - 2020-06-09

## base

- Added a new base class called `SupervisedTransformer` from which supervised transformers inherit from. Before this, supervised transformers has a `is_supervised` property.

## compose

- Added `compose.SelectType`, which allows selecting feature subsets based on their type.
- Added a `score_one` method to `compose.Pipeline` so that estimators from the `anomaly` module can be pipelined.
- Added `compose.Grouper`, which allows applying transformers within different subgroups.

## datasets

- Added `datasets.Music`, which is a dataset for multi-output binary classification.
- Added `datasets.synth.Friedman`, which is synthetic regression dataset.
- The `datasets.gen` module has been renamed to `datasets.synth`
- Each dataset now has a `__repr__` method which displays some descriptive information.
- Added `datasets.Insects`, which has 10 variants.

## feature_extraction

- `feature_extraction.Differ` has been deprecated. We might put it back in a future if we find a better design.

## impute

- `impute.StatImputer` has been completely refactored.

## metrics

- In `metrics.SMAPE`, instead of raising a `ZeroDivisionError`, the convention is now to use 0 when both `y_true` and `y_pred` are equal to 0.

## model_selection

- Added the possibility to configure how the progress is printed in `model_selection.progressive_val_score`. For instance, the progress can now be printed to a file by providing the `file` argument.

## multiclass

- Added `multiclass.OutputCodeClassifier`.
- Added `multiclass.OneVsOneClassifier`.

## multioutput

- Fixed a bug where `multioutput.ClassifierChain` and `multioutput.RegressorChain` could not be pickled.

## stats

- Added `stats.Shift`, which can be used to compute statistics over a shifted version of a variable.
- Added `stats.Link`, which can be used to compose univariate statistics. Univariate statistics can now be composed via the `|` operator.
- Renamed `stats.Covariance` to `stats.Cov`.
- Renamed `stats.PearsonCorrelation` to `stats.PearsonCorr`.
- Renamed `stats.AutoCorrelation` to `stats.AutoCorr`.
- Added `stats.RollingCov`, which computes covariance between two variables over a window.
- Added `stats.RollingPearsonCorr`, which computes the Pearson correlation over a window.

## stream

- Added a `stream.iter_sql` utility method to work with SQLAlchemy.
- The `target_name` parameter of `stream.iter_csv` has been renamed to `target`. It can now be passed a list of values in order to support multi-output scenarios.
- Added `stream.iter_arff` for handling ARFF files.

## tree

- Cancelled the behavior where `tree.DecisionTreeRegressor` would raise an exception when no split was found.
